;Adobe Helvetica normal
;-------------------------------------------------
;Berechnet den n�hsten Punkt eines Kreises
;-------------------------------------------------
;The result is the next point of a circle
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/KREIS.inc"
;%include "./INC/kreis-1.4.inc"
;%include "./INC/outnc2.3.inc"

;buf			resb	25
;Kreisx		dd	0		;Aktueller X-Wert des Kreises
;Kreisy		dd	0		;Aktueller Y-Wert des Kreises
;Kreisz		dd	0		;Aktueller Z-Wert des Kreises
;Praezision		dd	0		;Unterbrechung fr Loop
;Radius		dd	0		;Radius in Schritte

;kreisdev		db	0
;Bit	1 0
;	0 0		Kreis um die Z-Achse
;	0 1		Kreis um die Y-Achse
;	1 0		Kreis um die X-Achse
;	1 1		-

;Bit	2
;	0		linksrum
;	1		rechtsrum

;Bit 3=Wert der Achse 1|8 ist 0=(+), 1=(-)
;Bit 4=Wert der Achse 2|3 ist 0=(+), 1=(-)
;Bit	4 3
;	0 0		Kreissektor 1
;	0 1		Kreissektor 2
;	1 0		Kreissektor 3
;	1 1		Kreissektor 4

;Bit	5 4 3				changed
;	0 0 0		Sektor  1
;	0 0 1		Sektor  4
;	0 1 0		Sektor  8
;	0 1 1		Sektor  5
;	1 0 0		Sektor  2
;	1 0 1		Sektor  3
;	1 1 0		Sektor  7
;	1 1 1		Sektor  6

;-------------------------------------------------

KREIS:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,20
	int	80h					;lese 20 bytes ein
	cmp	eax,20
	jz	.a
	call	error1
	jmp	Ende
.a:
	cmp	dword[buf+15],0
	jnz	.a1
	jmp	.e
.a1:
	cmp	dword[buf+11],0
	jnz	.a2
	jmp	.e
.a2:
	mov	al,[buf]
	mov	[kreisdev],al
	mov	di,[buf+1]
	mov	edx,[buf+3]
	and	al,11b
	
	cmp	al,0					;um die Z-Achse
	jnz	.b5
	mov	[Kreisx],edx
	mov	edx,[buf+7]
	mov	[Kreisy],edx
	jmp	.c
.b5:
	cmp	al,1					;um die Y-Achse
	jnz	.b10
	mov	[Kreisx],edx
	mov	edx,[buf+7]
	mov	[Kreisz],edx
	jmp	.c
.b10:
	cmp	al,2					;um die X-Achse
	jnz	.b15
	mov	[Kreisy],edx
	mov	edx,[buf+7]
	mov	[Kreisz],edx
	jmp	.c
.b15:
	jmp	Ende
.c:
	mov	edx,[buf+11]
	mov	[Radius],edx

	mov	byte[statusB],0			;b statusB zurcksetzen
.d:
	call	brechner				;b setzt Delay
	call	kreis					;stellt Bewegung fuer outnc
	call	outnc
	cmp	di,0
	jz	.d2
	dec	di
	mov	ax,0					;b
	mov	al,[statusB]				;b kann bis Unterbrechung gebremst werden
	cmp	ax,di					;b Unterbrechung
	jb	.d1					;b
	or	byte[statusB],10000000b	;b bremsen
.d1:							;b
	cmp	di,0
	jz	.d5
.d2:
	dec	dword[buf+15]			;Schritte decrementieren
	mov	eax,0					;b
	mov	al,[statusB]				;b kann bis Ende gebremst werden
	cmp	eax,[buf+15]			;b Schritte
	jb	.d0					;b
	or	byte[statusB],10000000b	;b bremsen
.d0:
	cmp	dword[buf+15],0			;sind Schritte 0 ?
	jnz	.d
	jmp	.e
.d5:
	mov	al,[kreisdev]			;aktualisiere den buffer
	mov	[buf],al				;kreisdev speichern
	and	al,11b
	
	cmp	al,0
	jnz	.d10
	mov	eax,[Kreisx]			;um die Z-Achse speichern
	mov	[buf+3],eax
	mov	eax,[Kreisy]
	mov	[buf+7],eax
	jmp	.d20
.d10:
	cmp	al,1
	jnz	.d15
	mov	eax,[Kreisx]			;um die Y-Achse speichern
	mov	[buf+3],eax
	mov	eax,[Kreisz]
	mov	[buf+7],eax
	jmp	.d20
.d15:
	mov	eax,[Kreisy]			;um die X-Achse speichern
	mov	[buf+3],eax
	mov	eax,[Kreisz]
	mov	[buf+7],eax
.d20:
	cmp	dword[buf+15],0
	jz	.d21
	dec	dword[buf+15]					;ist ja ausgefuehrt worden
.d21:
	mov	eax,19				;setze den Dateizeiger
	mov	ebx,[datnum]
	mov	ecx,20				;20 Bytes
	neg	ecx					;niedriger
	mov	edx,1
	int	80h
	cmp	eax,0
	jg	.d25
	call	error1
	jmp	Ende
.d25:
	mov	eax,4					;schreibe
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,20				;20 Bytes (buffer)
	int	80h
	cmp	eax,20
	jz	.e
	call	error1
	jmp	Ende
.e:
	mov	al,[buf+19]				;naechster Befehl in al
	ret

